import { Runtime } from '@pajn/control-flow/cjs/runtime/entities';
import { Graph } from '@pajn/control-flow/cjs/schematic-core/entities';
import * as Hapi from 'hapi';
import { Modification, Plugin } from 'raxa-common';
import { Actions } from 'raxa-common/lib/plugin';
declare type Program = {
    id: string;
    name: string;
    graph: Graph;
};
declare type Settings = {
    programs: Record<string, Program>;
};
export default class ControlFlowPlugin extends Plugin {
    deviceStatusListeners: Set<(modification: Modification) => void>;
    runtimes: Map<string, Runtime>;
    server: Hapi.Server | undefined;
    getSettings: () => Settings;
    setSettings: (settings: Settings) => void;
    start(): Promise<void>;
    stop(): Promise<void>;
    onAction(action: Actions): void;
}
export {};
