import { Port } from '@pajn/control-flow/cjs/schematic-core/entities';
import ApolloClient from 'apollo-boost';
import { Property } from 'raxa-common';
export declare const getNodeTypes: (raxaClient: ApolloClient<any>) => {
    deviceStatusChanged: {
        id: string;
        name: string;
        group: string[];
        ports: {
            event: {
                id: string;
                kind: "EventOutput";
            };
        };
        properties: {
            device: {
                id: string;
                name: string;
                dataType: "Enum";
                required: true;
                getValues: () => Promise<any>;
            };
            interface: {
                id: string;
                name: string;
                dataType: "Enum";
                required: true;
                getValues: ({ device }: {
                    device?: string | undefined;
                }) => Promise<any> | never[];
            };
        };
        dynamicOverrides(properties: Record<string, string>): Promise<{
            ports: {
                [x: string]: Port;
            };
        }>;
    };
    getDeviceStatus: {
        id: string;
        name: string;
        group: string[];
        ports: {};
        properties: {
            device: {
                id: string;
                name: string;
                dataType: "Enum";
                required: true;
                getValues: () => Promise<any>;
            };
            interface: {
                id: string;
                name: string;
                dataType: "Enum";
                required: true;
                getValues: ({ device }: {
                    device?: string | undefined;
                }) => Promise<any> | never[];
            };
        };
        dynamicOverrides(properties: Record<string, string>): Promise<{
            ports: {
                [x: string]: Port;
            };
        }>;
    };
    setDeviceStatus: {
        id: string;
        name: string;
        group: string[];
        ports: {
            event: {
                id: string;
                kind: "EventInput";
            };
        };
        properties: {
            device: {
                id: string;
                name: string;
                dataType: "Enum";
                required: true;
                getValues: () => Promise<any>;
            };
            interface: {
                id: string;
                name: string;
                dataType: "Enum";
                required: true;
                getValues: ({ device }: {
                    device?: string | undefined;
                }) => Promise<any> | never[];
            };
            status: {
                id: string;
                name: string;
                dataType: "Enum";
                required: true;
                getValues: ({ device, interface: iface, }: {
                    device?: string | undefined;
                    interface?: string | undefined;
                }) => never[] | Promise<({
                    value: string;
                    name: string;
                    type: "action";
                    interfaceIds?: string[] | undefined;
                    deviceClassIds?: string[] | undefined;
                    id: string;
                    shortDescription?: string | undefined;
                    description?: string | undefined;
                    defaultValue?: any;
                    optional?: boolean | undefined;
                    modifiable?: boolean | undefined;
                    showInSettings?: boolean | undefined;
                } | {
                    value: string;
                    name: string;
                    type: "array";
                    defaultValue?: any[] | undefined;
                    items: Property;
                    minLength?: number | undefined;
                    maxLength?: number | undefined;
                    id: string;
                    shortDescription?: string | undefined;
                    description?: string | undefined;
                    optional?: boolean | undefined;
                    modifiable?: boolean | undefined;
                    showInSettings?: boolean | undefined;
                } | {
                    value: string;
                    name: string;
                    type: "boolean";
                    uiTypeHint?: "switch" | "checkbox" | undefined;
                    defaultValue?: boolean | undefined;
                    id: string;
                    shortDescription?: string | undefined;
                    description?: string | undefined;
                    optional?: boolean | undefined;
                    modifiable?: boolean | undefined;
                    showInSettings?: boolean | undefined;
                } | {
                    value: string;
                    name: string;
                    type: "device";
                    interfaceIds?: string[] | undefined;
                    deviceClassIds?: string[] | undefined;
                    id: string;
                    shortDescription?: string | undefined;
                    description?: string | undefined;
                    defaultValue?: any;
                    optional?: boolean | undefined;
                    modifiable?: boolean | undefined;
                    showInSettings?: boolean | undefined;
                } | {
                    value: string;
                    name: string;
                    type: "enum";
                    values: {
                        name: string;
                        value: string;
                    }[];
                    defaultValue?: string | undefined;
                    id: string;
                    shortDescription?: string | undefined;
                    description?: string | undefined;
                    optional?: boolean | undefined;
                    modifiable?: boolean | undefined;
                    showInSettings?: boolean | undefined;
                } | {
                    value: string;
                    name: string;
                    type: "modification";
                    interfaceIds?: string[] | undefined;
                    deviceClassIds?: string[] | undefined;
                    id: string;
                    shortDescription?: string | undefined;
                    description?: string | undefined;
                    defaultValue?: any;
                    optional?: boolean | undefined;
                    modifiable?: boolean | undefined;
                    showInSettings?: boolean | undefined;
                } | {
                    value: string;
                    name: string;
                    type: "number" | "integer";
                    defaultValue?: number | undefined;
                    min?: number | undefined;
                    max?: number | undefined;
                    unit?: string | undefined;
                    id: string;
                    shortDescription?: string | undefined;
                    description?: string | undefined;
                    optional?: boolean | undefined;
                    modifiable?: boolean | undefined;
                    showInSettings?: boolean | undefined;
                } | {
                    value: string;
                    name: string;
                    type: "object";
                    defaultValue?: {
                        [x: string]: any;
                    } | undefined;
                    properties: {
                        [x: string]: Property;
                    };
                    id: string;
                    shortDescription?: string | undefined;
                    description?: string | undefined;
                    optional?: boolean | undefined;
                    modifiable?: boolean | undefined;
                    showInSettings?: boolean | undefined;
                } | {
                    value: string;
                    name: string;
                    type: "string";
                    uiTypeHint?: "cronExpression" | "isoDate" | undefined;
                    defaultValue?: string | undefined;
                    unit?: string | undefined;
                    id: string;
                    shortDescription?: string | undefined;
                    description?: string | undefined;
                    optional?: boolean | undefined;
                    modifiable?: boolean | undefined;
                    showInSettings?: boolean | undefined;
                } | {
                    value: string;
                    name: string;
                    type: "void";
                    id: string;
                    shortDescription?: string | undefined;
                    description?: string | undefined;
                    defaultValue?: any;
                    optional?: boolean | undefined;
                    modifiable?: boolean | undefined;
                    showInSettings?: boolean | undefined;
                })[]>;
            };
        };
        dynamicOverrides(properties: Record<string, string>): Promise<{
            ports: {
                [x: string]: Port;
            };
        }>;
    };
    callDevice: {
        id: string;
        name: string;
        group: string[];
        ports: {
            event: {
                id: string;
                kind: "EventInput";
            };
            onDone: {
                id: string;
                name: string;
                kind: "EventOutput";
            };
            didError: {
                id: string;
                name: string;
                kind: "ValueOutput";
                dataType: "Bool";
            };
        };
        properties: {
            device: {
                id: string;
                name: string;
                dataType: "Enum";
                required: true;
                getValues: () => Promise<any>;
            };
            interface: {
                id: string;
                name: string;
                dataType: "Enum";
                required: true;
                getValues: ({ device }: {
                    device?: string | undefined;
                }) => Promise<any> | never[];
            };
            method: {
                id: string;
                name: string;
                dataType: "Enum";
                required: true;
                getValues: ({ device, interface: iface, }: {
                    device?: string | undefined;
                    interface?: string | undefined;
                }) => never[] | Promise<{
                    id: any;
                    value: any;
                    name: any;
                }[]>;
            };
        };
        dynamicOverrides(properties: Record<string, string>): Promise<{
            ports: {
                [x: string]: Port;
            };
        }>;
    };
    eventReceived: {
        id: string;
        name: string;
        group: string[];
        ports: {
            event: {
                id: string;
                kind: "EventOutput";
            };
        };
        properties: {
            interface: {
                id: string;
                name: string;
                dataType: "Enum";
                required: true;
                getValues: () => Promise<any>;
            };
            event: {
                id: string;
                name: string;
                dataType: "Enum";
                required: true;
                getValues: ({ interface: iface }: {
                    interface?: string;
                }) => never[] | Promise<{
                    id: any;
                    value: any;
                    name: any;
                }[]>;
            };
        };
        dynamicOverrides(properties: Record<string, string>): Promise<{
            ports: {
                [x: string]: Port;
            };
        }>;
    };
    fireEvent: {
        id: string;
        name: string;
        group: string[];
        ports: {
            event: {
                id: string;
                kind: "EventInput";
            };
        };
        properties: {
            interface: {
                id: string;
                name: string;
                dataType: "Enum";
                required: true;
                getValues: () => Promise<any>;
            };
            event: {
                id: string;
                name: string;
                dataType: "Enum";
                required: true;
                getValues: ({ interface: iface }: {
                    interface?: string;
                }) => never[] | Promise<{
                    id: any;
                    value: any;
                    name: any;
                }[]>;
            };
        };
        dynamicOverrides(properties: Record<string, string>): Promise<{
            ports: {
                [x: string]: Port;
            };
        }>;
    };
    getVariable: {
        id: string;
        name: string;
        ports: {
            value: {
                id: string;
                kind: "ValueOutput";
                dataType: "Any";
            };
        };
        properties: {
            name: {
                id: string;
                name: string;
                dataType: "String";
                required: true;
            };
        };
    };
    setVariable: {
        id: string;
        name: string;
        ports: {
            event: {
                id: string;
                kind: "EventInput";
            };
            value: {
                id: string;
                kind: "ValueInput";
                dataType: "Any";
            };
        };
        properties: {
            name: {
                id: string;
                name: string;
                dataType: "String";
                required: true;
            };
        };
    };
    httpRequest: {
        id: string;
        name: string;
        group: string[];
        ports: {
            event: {
                id: string;
                kind: "EventOutput";
            };
            value: {
                id: string;
                kind: "ValueOutput";
                dataType: "String";
            };
        };
        properties: {
            name: {
                id: string;
                name: string;
                dataType: "String";
                required: true;
            };
        };
    };
    switch: {
        id: string;
        name: string;
        group: string[];
        ports: {
            condition: {
                id: string;
                kind: "ValueInput";
                name: string;
                dataType: "Bool";
            };
            trueValue: {
                id: string;
                kind: "ValueInput";
                name: string;
                dataType: "Any";
            };
            falseValue: {
                id: string;
                kind: "ValueInput";
                name: string;
                dataType: "Any";
            };
            out: {
                id: string;
                kind: "ValueOutput";
                dataType: "Any";
            };
        };
        properties: {};
        dynamicOverrides(_: Record<string, any>, connections: Map<string, Port[]>): Promise<{
            ports?: undefined;
        } | {
            ports: {
                [x: string]: Port;
            };
        }>;
    };
};
